function EVAL_MATRIX = decision_tree_classifier(DATA, PARAMETERS)
%DECISION_TREE_CLASSIFIER - this function realizes a decision tree for
% classification. It uses the functions treefit() and treeval() from
% the Statistics Toolbox
%
% Possible parameters are:
%
% NONE

%% 1. INITIALISATION
[TRAINING_LENGTH, CLASSIFICATION_LENGTH, NUM_CLASSES, CLASSES, FEATURE_LENGTH] = get_lengths(DATA, PARAMETERS);

% initialize evaluation matrix
EVAL_MATRIX = [zeros(CLASSIFICATION_LENGTH, 1) DATA.CLASSIFICATION(:, end)];



%% 2. TRAININGSPHASE
TREE = treefit(DATA.TRAINING(:,1:FEATURE_LENGTH), DATA.TRAINING(:,end),'method','classification');


%% 3. CLASSIFICATIONPHASE
EVAL_MATRIX(:,1) = str2double(TREE.classname(treeval(TREE, DATA.CLASSIFICATION(:,1:FEATURE_LENGTH))));
