function DATA_OUT = decorrelate_matrix(DATA_IN)
% DECORRELATE_MATRIX - transforms a feature vector
% so that the new features are uncorrelated


[TRAINING_LENGTH, CLASSIFICATION_LENGTH, NUM_CLASSES, CLASSES, FEATURE_LENGTH] = get_lengths(DATA_IN, []);

COV_X   =  cov(DATA_IN.TRAINING(:, 1:FEATURE_LENGTH));

R = chol(COV_X);
DATA_OUT.TRAINING = [DATA_IN.TRAINING(:,1:FEATURE_LENGTH)*inv(R) DATA_IN.TRAINING(:,end)];

if isfield(DATA_IN,'CLASSIFICATION')
    DATA_OUT.CLASSIFICATION = [DATA_IN.CLASSIFICATION(:,1:FEATURE_LENGTH)*inv(R) DATA_IN.CLASSIFICATION(:,end)];
end