function Y = multivariatenormpdf(X, MU, COV_MAT)
%MULTIVARIATENORMPDF - returns the value of a gaussian pdf at the position X
% The function expects X to be a row vector
%
% If the value should be evaluated for more than one sample then use
% the Cholesky Factorization (see expectation_maximization_algorithm.m)
DIMENSION = length(MU);
Y = 1/(2*pi)^(DIMENSION/2)/sqrt(det(COV_MAT))*exp(-1/2*(X - MU)*inv(COV_MAT)*(X - MU)');
