function DATA_OUT = normalize_matrix(DATA_IN)
% NORMALIZE_MATRIX - normalizes a Feature Matrix
% this function works on column base

[TRAINING_LENGTH, CLASSIFICATION_LENGTH, NUM_CLASSES, CLASSES, FEATURE_LENGTH] = get_lengths(DATA_IN, []);

MU_X    = mean(DATA_IN.TRAINING(:, 1:FEATURE_LENGTH));
STD_X   =  std(DATA_IN.TRAINING(:, 1:FEATURE_LENGTH));

% if standard deviation is less than 1e-20 than do not
% transform this feature
STD_X(STD_X < 1e-15) = 1;

DATA_OUT.TRAINING = [(DATA_IN.TRAINING(:,1:FEATURE_LENGTH)-repmat(MU_X, TRAINING_LENGTH, 1))./repmat(STD_X, TRAINING_LENGTH, 1) DATA_IN.TRAINING(:,end)];

if isfield(DATA_IN,'CLASSIFICATION')
    DATA_OUT.CLASSIFICATION = [(DATA_IN.CLASSIFICATION(:,1:FEATURE_LENGTH)-repmat(MU_X, CLASSIFICATION_LENGTH, 1))./repmat(STD_X, CLASSIFICATION_LENGTH, 1) DATA_IN.CLASSIFICATION(:,end)];
end